Attribute VB_Name = "bApplication"
Option Explicit

Public APP_TITLE As String
Public CommonDialog As CommonDialog
Public SessionStartTime As Date

' ***** MODIFY *****
Public Const SUPPORT_EMAIL As String = "me@myhost.com"  ' The contact information given in _APP_LOG.txt

' Versioning ensures that your application won't read a file in an incompatible format.
' You only need to change the Version information if you have already released a version of the
' application and you later changed the fields in some way.

Public Const VBDB_VERSION_NUMBER As String = "1.0.10"
Public Const VBDB_VERSION_STRING = "VB DB Database" ' Use a unique version string for your application

' ***** END MODIFY *****

Private sHelpFile As String

Public Const BACKSLASH  As String = "\"
Public Const CHAR_SPACE As String = " "
Public Const CHAR_PERIOD As String = "."
Public Const DBL_QUOTE As String = """"
Public Const DBL_RETURN As String = vbCrLf & vbCrLf
Public Const MAX_PATH As Integer = 260

Public Property Get APP_FOLDER() As String

' Wrapper for App.Path.  Appends a backslash.

APP_FOLDER = NormalizePath(App.Path)

End Property
Public Property Get APP_LOG() As String

APP_LOG = APP_FOLDER & "_APP_LOG.txt"

End Property
Public Property Get APP_VERSION() As String

With App
  APP_VERSION = "Version " & .Major & CHAR_PERIOD & Format(.Minor, "00") & CHAR_PERIOD & Format$(.Revision, "00")
End With

End Property
Public Sub EndApplication()
Dim frm As Form

For Each frm In Forms
  UnloadForm frm
Next frm

CloseLogFile

End Sub
Public Function InitializeApplication(fAllowPreviousInstance As Boolean) As Long

On Error GoTo errHandler ' Returns Error Code

If Not fAllowPreviousInstance Then
  If App.PrevInstance Then End
End If

ChDrive APP_FOLDER

SessionStartTime = Now()

APP_TITLE = App.Title
SaveSetting APP_TITLE, "Application", "Path", APP_FOLDER

OpenLogFile

' Return 0

Exit Function

errHandler:
InitializeApplication = Err
LogError Error, Err, sHelpFile, "bApplication.InitializeApplication()"

End Function
Public Sub UnloadForm(frm As Form)

On Error Resume Next

Unload frm
Set frm = Nothing

End Sub
