Attribute VB_Name = "bVBDB"
'---------------------------------------------------------------------------------------
' Module    : bVBDB
' DateTime  : 6/5/2002 15:19
' Author    : Paul K. Johnson
' Purpose   : Declarations for VB DB
'---------------------------------------------------------------------------------------
Option Explicit

Public Enum FIELD_INDEX

  ' DO NOT MODIFY!

  RECORD_ID = 0
  DATE_CREATED = 1
  LAST_MODIFIED = 2
  FIELD_INDEX_MIN = LAST_MODIFIED + 1

  ' END DO NOT MODIFY

  ' ***** MODIFY *****

  ' These are the indexes for the Fields defined in your table.

  ' Add an index for each field in your table.
  ' Use descriptive Index names such as UserName, Street1, etc.
  ' The first field entered here should always equal FIELD_INDEX_MIN

  FIELD_01 = FIELD_INDEX_MIN
  FIELD_02
  FIELD_03
  FIELD_04
  FIELD_05
  FIELD_06
  FIELD_07
  FIELD_08

  ' FIELD_INDEX_MAX should always equal the last Enum entry
  FIELD_INDEX_MAX = FIELD_08

  ' ***** END MODIFY *****

End Enum

Public Enum COMPARISON_OPERATOR
  NOT_ENTERED = -1
  EQUAL = 0
  NOT_EQUAL = 1
  LESS_THAN = 2
  GREATER_THAN = 3
  LESS_THAN_OR_EQUAL = 4
  GREATER_THAN_OR_EQUAL = 5
End Enum

Public Enum DATA_TYPE
  dataBoolean = 1
  dataByte = 2
  dataCurrency = 3
  dataDate = 4
  dataDoublePrecision = 5
  dataInteger = 6
  dataLongInteger = 7
  dataSinglePrecision = 8
  dataString = 9
End Enum

Public Enum EDITING_MODE
  EDIT_MODE = 0
  ADD_NEW = 1
End Enum

Public Enum FIELD_DEFINITION
  fldIndex = 0
  fldSystemField = 1
  fldName = 2
  fldArray = 3
  fldDataType = 4
  fldDefaultValue = 5
  fldRequired = 6
  fldRequireUnique = 7
End Enum

Public Enum REPOSITION_TYPE
  MOVE_FIRST = 2
  MOVE_PREVIOUS = 3
  MOVE_NEXT = 4
  MOVE_LAST = 5
  MOVE_RECORDNUMBER = 6
  MOVE_RANDOM = 7
  DELETE_RECORD = 8
End Enum

Public Enum SEARCH_DIRECTION
  FIND_FIRST = 0
  FIND_PREVIOUS = 1
  FIND_NEXT = 2
  FIND_LAST = 3
End Enum

Public Enum SORT_DIRECTION
  SORT_ASCENDING = 0
  SORT_DESCENDING = 1
End Enum

Sub Main()

InitializeApplication True

Set CommonDialog = frmDatabase.CommonDialog1

frmDatabase.Show vbModeless

End Sub
Public Sub PopulateFieldNames(TBL As cTable, lst As Control)
Dim n As Long

' lst can be a ListBox or ComboBox

With lst
  .Clear
  For n = 0 To TBL.FieldCount - 1
    .AddItem TBL.FieldDefinitions(n, fldName)
    .ItemData(.NewIndex) = n
  Next n
  .ListIndex = 0
End With

End Sub
