VERSION 5.00
Begin VB.Form frmAdvancedSort 
   BorderStyle     =   3  'Fixed Dialog
   Caption         =   "Advanced Sort"
   ClientHeight    =   3360
   ClientLeft      =   45
   ClientTop       =   330
   ClientWidth     =   6450
   ControlBox      =   0   'False
   Icon            =   "frmAdvancedSort.frx":0000
   KeyPreview      =   -1  'True
   LinkTopic       =   "Form1"
   LockControls    =   -1  'True
   MaxButton       =   0   'False
   MinButton       =   0   'False
   ScaleHeight     =   3360
   ScaleWidth      =   6450
   ShowInTaskbar   =   0   'False
   StartUpPosition =   3  'Windows Default
   Begin VB.CommandButton cmdSort 
      Caption         =   "&Sort"
      Height          =   375
      Left            =   3780
      TabIndex        =   2
      TabStop         =   0   'False
      Top             =   2850
      WhatsThisHelpID =   3318
      Width           =   1215
   End
   Begin VB.CommandButton cmdClose 
      Cancel          =   -1  'True
      Caption         =   "&Close"
      Height          =   375
      Left            =   5070
      TabIndex        =   3
      TabStop         =   0   'False
      Top             =   2850
      WhatsThisHelpID =   3318
      Width           =   1215
   End
   Begin VB.ComboBox cmbSortDirection 
      BeginProperty Font 
         Name            =   "MS Sans Serif"
         Size            =   9.75
         Charset         =   0
         Weight          =   400
         Underline       =   0   'False
         Italic          =   0   'False
         Strikethrough   =   0   'False
      EndProperty
      Height          =   360
      Index           =   0
      ItemData        =   "frmAdvancedSort.frx":014A
      Left            =   5310
      List            =   "frmAdvancedSort.frx":014C
      Style           =   2  'Dropdown List
      TabIndex        =   1
      Top             =   150
      Width           =   975
   End
   Begin VB.ComboBox cmbSortField 
      BeginProperty Font 
         Name            =   "MS Sans Serif"
         Size            =   9.75
         Charset         =   0
         Weight          =   400
         Underline       =   0   'False
         Italic          =   0   'False
         Strikethrough   =   0   'False
      EndProperty
      Height          =   360
      Index           =   0
      Left            =   1110
      Sorted          =   -1  'True
      Style           =   2  'Dropdown List
      TabIndex        =   0
      Top             =   150
      Width           =   4095
   End
   Begin VB.Label lblSortField 
      AutoSize        =   -1  'True
      BackStyle       =   0  'Transparent
      Caption         =   "Sort by:"
      Height          =   195
      Index           =   0
      Left            =   120
      TabIndex        =   4
      Top             =   210
      Width           =   540
   End
End
Attribute VB_Name = "frmAdvancedSort"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Option Explicit

Public Cancelled As Boolean

Private m_Table As cTable

Private nSortDirection() As SORT_DIRECTION
Private nSortField() As Long

Private Sub PopulateComboBoxes()
Dim i As Integer
Dim iCount As Integer

iCount = IIf(m_Table.FieldCount > 5, 5, m_Table.FieldCount)

For i = 1 To iCount - 1
  Load cmbSortField(i)
  Load cmbSortDirection(i)
  cmbSortField(i).Top = cmbSortField(i - 1).Top + cmbSortField(i - 1).Height + 90
  cmbSortDirection(i).Top = cmbSortField(i).Top
Next i

For i = 0 To cmbSortField.UBound
  PopulateFieldNames m_Table, cmbSortField(i)
Next i

For i = cmbSortField.LBound To cmbSortField.UBound
  cmbSortField(i).AddItem vbNullString, 0
  cmbSortField(i).ListIndex = 0
  cmbSortDirection(i).AddItem vbNullString
  cmbSortDirection(i).ItemData(cmbSortDirection(i).NewIndex) = 0
  cmbSortDirection(i).AddItem "ASC"
  cmbSortDirection(i).ItemData(cmbSortDirection(i).NewIndex) = SORT_ASCENDING
  cmbSortDirection(i).AddItem "DESC"
  cmbSortDirection(i).ItemData(cmbSortDirection(i).NewIndex) = SORT_DESCENDING
  cmbSortField(i).Visible = True
  cmbSortDirection(i).Visible = True
Next i

End Sub
Public Property Get SortDirection(Index As Integer) As SORT_DIRECTION

SortDirection = nSortDirection(Index)

End Property
Public Property Get SortField(Index As Integer) As FIELD_INDEX

SortField = nSortField(Index)

End Property
Public Property Get SortFieldCount() As Long

If Not ArrayInitialized(nSortField) Then Exit Property

SortFieldCount = UBound(nSortField) + 1

End Property
Public Property Set Table(TBL As cTable)

Set m_Table = TBL

PopulateComboBoxes

End Property
Private Sub cmbSortField_Change(Index As Integer)

cmbSortField_Click Index

End Sub
Private Sub cmbSortField_Click(Index As Integer)

On Error Resume Next

If cmbSortField(Index).ListIndex = 0 Then
  cmbSortDirection(Index).ListIndex = 0
  Exit Sub
End If

If cmbSortDirection(Index).Text = vbNullString Then
  cmbSortDirection(Index).ListIndex = 1
End If

End Sub
Private Sub cmdClose_Click()

Cancelled = True
Hide

End Sub
Private Sub cmdSort_Click()
Dim i As Integer

Erase nSortDirection
Erase nSortField

For i = cmbSortField.LBound To cmbSortField.UBound
  ' Stop adding fields at first empty value
  If cmbSortField(i).Text = vbNullString Then Exit For
  If Not ArrayInitialized(nSortField) Then
    ReDim nSortField(0)
    ReDim nSortDirection(0)
  Else
    ReDim Preserve nSortField(UBound(nSortField) + 1)
    ReDim Preserve nSortDirection(UBound(nSortDirection) + 1)
  End If
  
  nSortField(i) = cmbSortField(i).ItemData(cmbSortField(i).ListIndex)
  nSortDirection(i) = cmbSortDirection(i).ItemData(cmbSortDirection(i).ListIndex)
Next i

Cancelled = False
Hide

End Sub
Private Sub Form_KeyDown(KeyCode As Integer, Shift As Integer)

Select Case KeyCode
  Case Is = vbKeyReturn
    SendKeys "{Tab}"
End Select

End Sub
