VERSION 5.00
Begin VB.Form frmFieldProperties 
   BorderStyle     =   3  'Fixed Dialog
   Caption         =   "Field Properties"
   ClientHeight    =   3270
   ClientLeft      =   2760
   ClientTop       =   3750
   ClientWidth     =   5970
   ControlBox      =   0   'False
   Icon            =   "frmFieldProperties.frx":0000
   KeyPreview      =   -1  'True
   LinkTopic       =   "Form1"
   LockControls    =   -1  'True
   MaxButton       =   0   'False
   MinButton       =   0   'False
   ScaleHeight     =   3270
   ScaleWidth      =   5970
   ShowInTaskbar   =   0   'False
   StartUpPosition =   1  'CenterOwner
   Begin VB.Frame framFieldDefinitions 
      Height          =   2535
      Left            =   150
      TabIndex        =   13
      Top             =   90
      Width           =   5655
      Begin VB.CheckBox chkUnique 
         Caption         =   "&Unique (No Duplicates Allowed)"
         Height          =   195
         Left            =   1350
         TabIndex        =   10
         Top             =   2100
         Width           =   2655
      End
      Begin VB.ComboBox cmbBoolean 
         Height          =   315
         Left            =   1350
         Style           =   2  'Dropdown List
         TabIndex        =   7
         Top             =   1590
         Width           =   1395
      End
      Begin VB.ComboBox cmbDataType 
         Height          =   315
         Left            =   1350
         Style           =   2  'Dropdown List
         TabIndex        =   5
         Top             =   1110
         Width           =   4095
      End
      Begin VB.TextBox txtDefaultValue 
         Height          =   315
         Left            =   1350
         TabIndex        =   8
         Top             =   1590
         Width           =   4095
      End
      Begin VB.TextBox txtFieldName 
         Height          =   315
         Left            =   1350
         TabIndex        =   3
         Top             =   690
         Width           =   4095
      End
      Begin VB.CheckBox chkRequired 
         Caption         =   "&Required"
         Height          =   195
         Left            =   210
         TabIndex        =   9
         Top             =   2100
         Width           =   1035
      End
      Begin VB.ComboBox cmbFields 
         Height          =   315
         Left            =   1350
         Sorted          =   -1  'True
         Style           =   2  'Dropdown List
         TabIndex        =   1
         Top             =   270
         Width           =   4095
      End
      Begin VB.Label lblDataType 
         BackStyle       =   0  'Transparent
         Caption         =   "Data &Type:"
         Height          =   195
         Left            =   210
         TabIndex        =   4
         Top             =   1200
         Width           =   795
      End
      Begin VB.Label lblDefaultValue 
         BackStyle       =   0  'Transparent
         Caption         =   "&Default Value:"
         Height          =   195
         Left            =   210
         TabIndex        =   6
         Top             =   1650
         Width           =   1005
      End
      Begin VB.Label lblFields 
         BackStyle       =   0  'Transparent
         Caption         =   "&Fields"
         Height          =   195
         Left            =   210
         TabIndex        =   0
         Top             =   330
         Width           =   405
      End
      Begin VB.Label lblFieldName 
         BackStyle       =   0  'Transparent
         Caption         =   "Field &Name:"
         Height          =   195
         Left            =   210
         TabIndex        =   2
         Top             =   750
         Width           =   840
      End
   End
   Begin VB.CommandButton cmdSave 
      Caption         =   "&Save"
      Height          =   375
      Left            =   4590
      TabIndex        =   12
      Top             =   2760
      Width           =   1215
   End
   Begin VB.CommandButton cmdCancel 
      Cancel          =   -1  'True
      Caption         =   "&Cancel"
      Height          =   375
      Left            =   3300
      TabIndex        =   11
      Top             =   2760
      Width           =   1215
   End
End
Attribute VB_Name = "frmFieldProperties"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Option Explicit

Private m_Table As cTable

Private fChanged As Boolean
Private fLoading As Boolean
Private LastIndex As Long

Private fRequired() As Boolean
Private fRequireUnique() As Boolean
Private nDataType() As DATA_TYPE
Private nField() As FIELD_INDEX
Private sName() As String
Private v_Default() As Variant

Private Property Get Changed() As Boolean

Changed = fChanged

End Property
Private Property Let Changed(f As Boolean)

fChanged = f

End Property
Private Function DuplicateFieldName(sNewName As String, Index As Long)
Dim n As Long

For n = LBound(sName) To UBound(sName)
  If n <> Index And StrComp(sNewName, sName(n), vbTextCompare) = 0 Then
    DuplicateFieldName = True
    Exit Function
  End If
Next n

End Function
Private Sub GetData(Index As Long)

cmbDataType.ListIndex = ListIndexFromItemData(cmbDataType, nDataType(Index))

If nDataType(Index) = dataBoolean Then
  If IsEmpty(v_Default(Index)) Then
    cmbBoolean.ListIndex = 0
  Else
    If IsNumeric(v_Default(Index)) Then
      cmbBoolean.ListIndex = IIf(v_Default(Index), 1, 0)
    Else
      cmbBoolean.ListIndex = 0
    End If
  End If
  cmbBoolean.Visible = True
  txtDefaultValue.Visible = False
Else
  txtDefaultValue.Visible = True
  cmbBoolean.Visible = False
  txtDefaultValue.Text = v_Default(Index)
End If

txtFieldName.Text = sName(Index)
chkRequired.Value = IIf(fRequired(Index), vbChecked, vbUnchecked)
chkUnique.Value = IIf(fRequireUnique(Index), vbChecked, vbUnchecked)

End Sub
Private Sub GetFieldDefinitions()
Dim n As Long

With m_Table
  ReDim fRequired(FIELD_INDEX_MIN To .FieldCount - 1)
  ReDim fRequireUnique(FIELD_INDEX_MIN To .FieldCount - 1)
  ReDim nDataType(FIELD_INDEX_MIN To .FieldCount - 1)
  ReDim nField(FIELD_INDEX_MIN To .FieldCount - 1)
  ReDim sName(FIELD_INDEX_MIN To .FieldCount - 1)
  ReDim v_Default(FIELD_INDEX_MIN To .FieldCount - 1)

  For n = FIELD_INDEX_MIN To .FieldCount - 1
    fRequired(n) = .FieldDefinitions(n, fldRequired)
    fRequireUnique(n) = .FieldDefinitions(n, fldRequireUnique)
    nDataType(n) = .FieldDefinitions(n, fldDataType)
    nField(n) = n
    sName(n) = .FieldDefinitions(n, fldName)
    v_Default(n) = .FieldDefinitions(n, fldDefaultValue)
  Next n
End With

End Sub
Private Sub PopulateComboBoxes()
Dim n As Long

With cmbDataType
  .AddItem "Boolean"
  .ItemData(.NewIndex) = dataBoolean
  .AddItem "Byte"
  .ItemData(.NewIndex) = dataByte
  .AddItem "Currency"
  .ItemData(.NewIndex) = dataCurrency
  .AddItem "Date/Time"
  .ItemData(.NewIndex) = dataDate
  .AddItem "Double Precision numeric"
  .ItemData(.NewIndex) = dataDoublePrecision
  .AddItem "Integer"
  .ItemData(.NewIndex) = dataInteger
  .AddItem "Long Integer"
  .ItemData(.NewIndex) = dataLongInteger
  .AddItem "Single Precision numeric"
  .ItemData(.NewIndex) = dataSinglePrecision
  .AddItem "Text/Memo"
  .ItemData(.NewIndex) = dataString
  .ListIndex = 0
End With

With cmbBoolean
  .AddItem "False"
  .ItemData(.NewIndex) = 0
  .AddItem "True"
  .ItemData(.NewIndex) = 1
  .ListIndex = 0
End With

With m_Table
  For n = FIELD_INDEX_MIN To .FieldCount - 1
    cmbFields.AddItem .FieldDefinitions(n, fldName)
    cmbFields.ItemData(cmbFields.NewIndex) = n
  Next n
End With

End Sub
Private Function Save() As Long
Dim n As Long
Dim nReturn As Long

On Error GoTo errHandler

SetData cmbFields.ItemData(cmbFields.ListIndex)

nReturn = Validate
If nReturn <> 0 Then Err.Raise nReturn

With m_Table
  For n = LBound(sName) To UBound(sName)
    If Trim$(sName(n)) = vbNullString Then Err.Raise ERR_FIELD_NAME_REQUIRED
    If DuplicateFieldName(sName(n), n) Then Err.Raise ERR_DUPLICATE_FIELD_NAME
  Next n
End With

With m_Table
  For n = LBound(sName) To UBound(sName)
    .FieldDefinitions(n, fldRequired) = fRequired(n)
    .FieldDefinitions(n, fldRequireUnique) = fRequireUnique(n)
    .FieldDefinitions(n, fldDataType) = nDataType(n)
    .FieldDefinitions(n, fldName) = sName(n)
    .FieldDefinitions(n, fldDefaultValue) = v_Default(n)
  Next n
End With

MsgBox "New Field definitions are now in effect.  They will not become permanent until a record is saved.", vbInformation, APP_TITLE

Changed = False

Exit Function

errHandler:
Save = Err
ErrorHandler Error, Err, "Field: " & m_Table.FieldDefinitions(n, fldName), Me.Name & ".Save()"

End Function
Private Sub SetData(Index As Long)
Static fStarted As Boolean

If Not fStarted Then
  fStarted = True
  Exit Sub
End If

fRequired(Index) = IIf(chkRequired.Value = vbChecked, True, False)
fRequireUnique(Index) = IIf(chkUnique.Value = vbChecked, True, False)
nDataType(Index) = cmbDataType.ItemData(cmbDataType.ListIndex)
sName(Index) = Trim$(txtFieldName.Text)

If cmbDataType.ItemData(cmbDataType.ListIndex) = dataBoolean Then
  v_Default(Index) = IIf(cmbBoolean.ListIndex = 0, False, True)
Else
  v_Default(Index) = txtDefaultValue.Text
End If

End Sub
Public Property Set Table(TBL As cTable)

fLoading = True

Set m_Table = TBL

PopulateComboBoxes

GetFieldDefinitions

fLoading = False

LastIndex = FIELD_INDEX_MIN
cmbFields.ListIndex = 0

Changed = False

End Property
Private Function Validate() As Long
Dim n As Long
Dim nErr As Long
Dim X As Variant

On Error GoTo errHandler ' Returns Error Code

For n = LBound(v_Default) To UBound(v_Default)
  If Trim$(CStr(v_Default(n))) <> vbNullString Then
    Select Case nDataType(n)

      Case Is = dataBoolean
        nErr = ERR_DATA_BOOLEAN_OUT_OF_RANGE
        X = CBool(v_Default(n))

      Case Is = dataByte
        nErr = ERR_DATA_BYTE_OUT_OF_RANGE
        X = CByte(v_Default(n))

      Case Is = dataCurrency
        nErr = ERR_DATA_CURRENCY_OUT_OF_RANGE
        X = CCur(v_Default(n))

      Case Is = dataDate
        nErr = ERR_DATA_DATE_OUT_OF_RANGE
        X = CDate(v_Default(n))

      Case Is = dataDoublePrecision
        nErr = ERR_DATA_DOUBLE_PRECISION_OUT_OF_RANGE
        X = CDbl(v_Default(n))

      Case Is = dataInteger
        nErr = ERR_DATA_INTEGER_OUT_OF_RANGE
        X = CInt(v_Default(n))

      Case Is = dataLongInteger
        nErr = ERR_DATA_LONG_INTEGER_OUT_OF_RANGE
        X = CLng(v_Default(n))

      Case Is = dataSinglePrecision
        nErr = ERR_DATA_SINGLE_PRECISION_OUT_OF_RANGE
        X = CSng(v_Default(n))

      Case Is = dataString
        X = CStr(v_Default(n))

    End Select
  End If
Next n

' No error
Validate = 0

Exit Function

errHandler:
If nErr = 0 Then
  Validate = Err
Else
  Validate = nErr
End If

End Function
Private Sub chkRequired_Click()

Changed = True

End Sub
Private Sub chkUnique_Click()

Changed = True

End Sub
Private Sub cmbBoolean_Change()

Changed = True

End Sub
Private Sub cmbBoolean_Click()

Changed = True

End Sub
Private Sub cmbDataType_Change()

Changed = True

End Sub
Private Sub cmbDataType_Click()

Changed = True

End Sub
Private Sub cmbFields_Change()

cmbFields_Click

End Sub
Private Sub cmbFields_Click()
Dim fChanged As Boolean

On Error GoTo errHandler

If fLoading Then Exit Sub

' Save Changed state
fChanged = Changed

SetData LastIndex
GetData cmbFields.ItemData(cmbFields.ListIndex)
LastIndex = cmbFields.ItemData(cmbFields.ListIndex)

' Restore Changed state
Changed = fChanged

Exit Sub

errHandler:
MsgBox Error

End Sub
Private Sub cmdCancel_Click()
Dim nReturn As Long

If Changed Then
  nReturn = MsgBox("Save changes?", vbYesNoCancel + vbQuestion, APP_TITLE)
  Select Case nReturn
    Case Is = vbYes
      nReturn = Save
      If nReturn <> 0 Then Exit Sub
    Case Is = vbNo
      ' Do nothing
    Case Is = vbCancel
      Exit Sub
  End Select
End If

Hide

End Sub
Private Sub cmdSave_Click()
Dim nReturn As Long

nReturn = Save
If nReturn <> 0 Then Exit Sub

Hide

End Sub
Private Sub Form_KeyDown(KeyCode As Integer, Shift As Integer)

Select Case KeyCode
  Case Is = vbKeyReturn
    SendKeys "{Tab}"
End Select

End Sub
Private Sub txtDefaultValue_Change()

Changed = True

End Sub
Private Sub txtDefaultValue_GotFocus()

SelectAllText txtDefaultValue

End Sub
Private Sub txtFieldName_Change()

Changed = True

End Sub
Private Sub txtFieldName_GotFocus()

SelectAllText txtFieldName

End Sub
